Uses Splay;

Var vstup, vysledek : Text;
    x : Integer;
    b : Integer;
    T : PTree;
    ok : Boolean;


Procedure pridej(var T : PTree; x : Integer);
Begin
  If T = Nil Then
    Begin
      New(T);
      T^.l := Nil;
      T^.r := Nil;
      T^.x := x;
    End
  Else
      If x < T^.x Then
        pridej(T^.l, x)
      Else If x > T^.x Then
        pridej(T^.r, x);
End;


{ nacte radek a vyrobi z nej strom }
Function vyrob_strom(var F : Text) : PTree;
Var T : PTree;
    x : Integer;
Begin
  T := Nil; { prazdny strom }

  While Not Eoln(F) Do
    Begin
      Read(F, x);
      pridej(T, x);
    End;

  Readln(F); { preskoceni na dalsi radek }

  vyrob_strom := T;
End;


Procedure zrus_strom(T : PTree);
Begin
  If T <> Nil Then
    Begin
      zrus_strom(T^.l);
      zrus_strom(T^.r);
      dispose(T);
    End;
End;


{ porovna dva stromy }
Function stejne(T, U : PTree) : Boolean;
Begin
  If T = Nil Then
    stejne := U = Nil
  Else If U = Nil Then
    stejne := False
  Else { T <> Nil, U <> Nil }
    stejne := (T^.x = U^.x) And stejne(T^.l, U^.l) And stejne(T^.r, U^.r);
End;

{ porovna strom T se stromem nactenym z F }
Function zkontroluj_strom(T : PTree; var F : Text) : Boolean;
Var U : PTree;
Begin
  U := vyrob_strom(F);
  zkontroluj_strom := stejne(T, U);
  zrus_strom(U)
End;

Begin

Assign(vstup, 'vstup.txt');
Reset(vstup);

Assign(vysledek, 'vysledek.txt');
Rewrite(vysledek);

While Not Eof(vstup) Do
  Begin
    T := vyrob_strom(vstup);
    Readln(vstup, x, b);
    ok := b = ord(member(T, x));
    If ok Then ok := zkontroluj_strom(T, vstup) Else Readln(vstup);

    If ok Then Writeln(vysledek, 'ok') Else Writeln(vysledek, 'spatne');

    zrus_strom(T);
  End;


Close(vstup);
Close(vysledek);


End.
